<?php
echo '<style type="text/css">';
Shop::Smarty()->display($plugin->getPaths()->getAdminPath() . 'templates/style.tpl');
echo '</style>';
		
$action = isset($_REQUEST['action']) ? trim($_REQUEST['action']) : 'overview';

function utf8_converter_formeln($array)
{
	return $array; //Stop because Shop 5 is now UTF-8
	array_walk_recursive($array, function(&$item, $key){
		if(!mb_detect_encoding($item, 'utf-8', true)){
			$item = htmlentities($item);
			$item = str_replace("&nbsp;", " ", $item);
			$item = html_entity_decode($item);
			$item = trim($item);
			$item = utf8_encode($item);
		}
	});
	return $array;
}
   
   
\Shop::Smarty()->registerPlugin('modifier', 'formel', 'formel');
function formel($formel)
{
	$formel = str_replace('##price##','<span contenteditable="false" class="eigenschaft price" data-value="price">Preis</span>',$formel);
	$formel = str_replace('##quantity##','<span contenteditable="false" class="eigenschaft quantity" data-value="quantity">Anzahl</span>',$formel);
	$formel = str_replace('##gewicht##','<span contenteditable="false" class="eigenschaft gewicht" data-value="gewicht">Gewicht</span>',$formel);
	$formel = preg_replace_callback('|##e\:([0-9]*)##|',function($treffer){
		//Alle Eigenschaften durchgehen!
        $fields = Shop::Smarty()->getTemplateVars('fields');

		foreach($fields as $field)
		{
			if($field->kEigenschaft == $treffer[1])
			{
				return '<span contenteditable="false" class="eigenschaft" data-value="'.$treffer[1].'">'.$field->cName.'</span>';
			}
		}
		return $treffer;
	},$formel);
	return $formel;
}

if(isset($_REQUEST['saveManipulations']))
{
	//Zuerst alte Manipulationen löschen
	if(isset($_REQUEST['kArtikel']) && (int) $_REQUEST['kArtikel'] > 0)
		Shop::Container()->getDB()->delete('xplugin_km_artikelpreise_manipulation', 'kArtikel', (int) $_REQUEST['kArtikel']);
	else
		Shop::Container()->getDB()->delete('xplugin_km_artikelpreise_manipulation', 'fktattr', trim($_REQUEST['fktattr']));

	if(isset($_POST['config']))
	{
		foreach($_POST['config'] as $manipulation)
		{
			$obj = new stdClass;
			$obj->kArtikel = isset($_REQUEST['kArtikel']) ? (int) $_REQUEST['kArtikel'] : 0;
			$obj->name = isset($manipulation['name']) ? trim($manipulation['name']) : '';
			$obj->fktattr = isset($_REQUEST['fktattr']) ? strtolower(trim($_REQUEST['fktattr'])) : '';
			$obj->sort = $manipulation['sort'];
			//$manipulation = utf8_converter_formeln($manipulation); Not more needed
			$obj->formel = json_encode($manipulation);
			Shop::Container()->getDB()->insert('xplugin_km_artikelpreise_manipulation',$obj);
		}
		\Shop::Smarty()->assign('success','Manipulationen erfolgreich gespeichert.');
	} else {
		\Shop::Smarty()->assign('success','Keine Preismanipulationen angegeben, falls vorher welche vorhanden waren sind diese nun entfernt worden.');
	}
	Shop::Container()->getCache()->flush('km_artikelpreise');
	
	$action = 'manipulations';
}

if($action == 'saveBasics')
{
	$artNr = trim($_REQUEST['cArtNr']);
	if(!$artNr)
	{
		$fktattr = trim($_REQUEST['fktattr']);
		if(!$fktattr)
		{
			$action = 'overview';
			\Shop::Smarty()->assign('error','Zum Speichern bitte eine Artikelnummer oder ein Funktionsattribut angeben.');
		} else {
			$basic = new stdClass;
			$basic->kArtikel = 0;
			$basic->fktattr = strtolower($fktattr);
			$basic->berechnungsBasis = ($_REQUEST['berechnungsBasis'] == "brutto") ? true : false;
			$res =  Shop::Container()->getDB()->insert('xplugin_km_artikelpreise_basics',$basic);
			if($res > 0)
			{
				$action = 'overview';
                if(isset($artikel))
                {
                    \Shop::Smarty()->assign('success','Der Artikel <strong>'.$artikel->cName.'</strong> wurde in die Preiskonfiguration aufgenommen. 
								Du kannst jetzt die <a href="plugin.php?kPlugin='.$oPlugin->getID().'&amp;action=fields&amp;kArtikel='.$artikel->kArtikel.'">Felder bearbeiten</a>
								und <a href="plugin.php?kPlugin='.$oPlugin->getID().'&amp;action=manipulations&amp;kArtikel='.$artikel->kArtikel.'">Preiskonfigurationen</a> vornehmen.');
                } else {
                    \Shop::Smarty()->assign('success','Das Funktionsattribut <strong>'.$basic->fktattr.'</strong> wurde in die Preiskonfiguration aufgenommen.');
                }
			} else {
				$action = 'overview';
				\Shop::Smarty()->assign('error','Der angegebene Artikel konnte nicht als neue Preiskonfiguration gespeichert werden.');
			}
		}
	} else {
		//Hole die kArtikelnr
		$sqlkArtikel = 'SELECT kArtikel,cName FROM tartikel WHERE cArtNr=:cArtNr';
		$artikel = Shop::Container()->getDB()->select('tartikel','cArtNr',$artNr);
		if(!$artikel)
		{
			$action = 'overview';
			\Shop::Smarty()->assign('error','Der angegebene Artikel konnte nicht gefunden werden');
		} else {
			$basic = new stdClass;
			$basic->kArtikel = $artikel->kArtikel;
			$basic->fktattr = '';
			$basic->berechnungsBasis = ($_REQUEST['berechnungsBasis'] == "brutto") ? true : false;
			$res =  Shop::Container()->getDB()->insert('xplugin_km_artikelpreise_basics',$basic);
			if($res > 0)
			{
				$action = 'overview';
				\Shop::Smarty()->assign('success','Der Artikel <strong>'.$artikel->cName.'</strong> wurde in die Preiskonfiguration aufgenommen. 
								Du kannst jetzt die <a href="plugin.php?kPlugin='.$oPlugin->getID().'&amp;action=fields&amp;kArtikel='.$artikel->kArtikel.'">Felder bearbeiten</a>
								und <a href="plugin.php?kPlugin='.$oPlugin->getID().'&amp;action=manipulations&amp;kArtikel='.$artikel->kArtikel.'">Preiskonfigurationen</a> vornehmen.');
			} else {
				$action = 'overview';
				\Shop::Smarty()->assign('error','Der angegebene Artikel konnte nicht als neue Preiskonfiguration gespeichert werden.');
			}
		}
	}
	Shop::Container()->getCache()->flush('km_artikelpreise');
}

if($action == 'saveEditBasics')
{
	$artNr = trim($_REQUEST['cArtNr']);
	//Hole die kArtikelnr
	$sqlkArtikel = 'SELECT kArtikel,cName FROM tartikel WHERE cArtNr=:cArtNr';
	$artikel = Shop::Container()->getDB()->select('tartikel','cArtNr',$artNr);
	if(!$artikel)
	{
		$action = 'overview';
		\Shop::Smarty()->assign('error','Der angegebene Artikel konnte nicht gefunden werden');
	} else {
		$basic = new stdClass;
		$basic->kArtikel = $artikel->kArtikel;
		$basic->berechnungsBasis = ($_REQUEST['berechnungsBasis'] == "brutto") ? true : false;
		$res =  Shop::Container()->getDB()->update('xplugin_km_artikelpreise_basics','kArtikel',$basic->kArtikel,$basic);
		if($res > 0)
		{
			$action = 'overview';
			\Shop::Smarty()->assign('success','Der Artikel <strong>'.$artikel->cName.'</strong> wurde erfolgreich bearbeitet. 
							Du kannst jetzt die <a href="plugin.php?kPlugin='.$oPlugin->getID().'&amp;action=fields&amp;kArtikel='.$artikel->kArtikel.'">Felder bearbeiten</a>
							und <a href="plugin.php?kPlugin='.$oPlugin->getID().'&amp;action=manipulations&amp;kArtikel='.$artikel->kArtikel.'">Preiskonfigurationen</a> vornehmen.');
		} else {
			$action = 'overview';
			\Shop::Smarty()->assign('error','Der angegebene Artikel konnte nicht bearbeitet werden.');
		}
	}
	Shop::Container()->getCache()->flush('km_artikelpreise');
}

if($action == 'editArtikel')
{
	$artikel = Shop::Container()->getDB()->select('tartikel','kArtikel',$_REQUEST['kArtikel']);
	$basic = Shop::Container()->getDB()->select('xplugin_km_artikelpreise_basics','kArtikel',$_REQUEST['kArtikel']);
	if($artikel && $basic)
	{
		\Shop::Smarty()->assign('artikel',$artikel);
		\Shop::Smarty()->assign('basic',$basic);
	} else {
		$action = 'overview';
		\Shop::Smarty()->assign('error','Der angegebene Artikel konnte nicht gefunden werden');
	}
	Shop::Container()->getCache()->flush('km_artikelpreise');
}

if($action == 'delArtikel')
{
	//Artikelkonfiguration entfernen
	$action = 'overview';
	Shop::Container()->getDB()->delete('xplugin_km_artikelpreise_basics', 'kArtikel', (int) $_REQUEST['kArtikel']);
	Shop::Container()->getDB()->delete('xplugin_km_artikelpreise_variationen', 'kArtikel', (int) $_REQUEST['kArtikel']);
	Shop::Container()->getDB()->delete('xplugin_km_artikelpreise_manipulation', 'kArtikel', (int) $_REQUEST['kArtikel']);
	\Shop::Smarty()->assign('success','Die Preiskonfiguration des angegebenen Artikels wurde vollst&auml;ndig entfernt.');
	
	Shop::Container()->getCache()->flush('km_artikelpreise');
}

if($action == 'delFktattr')
{
	//Artikelkonfiguration entfernen
	$action = 'overview';
	Shop::Container()->getDB()->delete('xplugin_km_artikelpreise_basics', 'fktattr', trim($_REQUEST['fktattr']));
	Shop::Container()->getDB()->delete('xplugin_km_artikelpreise_variationen', 'fktattr', trim($_REQUEST['fktattr']));
	Shop::Container()->getDB()->delete('xplugin_km_artikelpreise_manipulation', 'fktattr', trim($_REQUEST['fktattr']));
	\Shop::Smarty()->assign('success','Die Preiskonfiguration des angegebenen Funktionsattributs wurde vollst&auml;ndig entfernt.');
	
	Shop::Container()->getCache()->flush('km_artikelpreise');
}

if(isset($_REQUEST['saveFields']))
{
	if(isset($_REQUEST['kArtikel']) && (int) $_REQUEST['kArtikel'] > 0)
	{
		//Zuerst alte Feldzuordnungen löschen
		Shop::Container()->getDB()->delete('xplugin_km_artikelpreise_variationen', 'kArtikel', (int) $_REQUEST['kArtikel']);
		
		//Jetzt die neuen durchgehen
		$fields = Shop::Container()->getDB()->selectAll('teigenschaft','kartikel',(int) $_REQUEST['kArtikel']);
	} else {
		Shop::Container()->getDB()->delete('xplugin_km_artikelpreise_variationen', 'fktattr', trim($_REQUEST['fktattr']));
		$fields = array(
			(object)array('kEigenschaft' => 1),
			(object)array('kEigenschaft' => 2),
			(object)array('kEigenschaft' => 3),
			(object)array('kEigenschaft' => 4),
			(object)array('kEigenschaft' => 5),
			(object)array('kEigenschaft' => 6),
			(object)array('kEigenschaft' => 7),
			(object)array('kEigenschaft' => 8),
			(object)array('kEigenschaft' => 9),
			(object)array('kEigenschaft' => 10)
		);
	}
	foreach($fields as $field)
	{
		if(isset($_REQUEST['overwrite'][$field->kEigenschaft]) && $_REQUEST['overwrite'][$field->kEigenschaft] == 1)
		{
			$x = new stdClass;
			$x->kArtikel = isset($_REQUEST['kArtikel']) ? (int) $_REQUEST['kArtikel'] : 0;
			$x->fktattr = isset($_REQUEST['fktattr']) ? trim($_REQUEST['fktattr']) : '';
			$x->kEigenschaft = $field->kEigenschaft;
			if(!empty($_REQUEST['min'][$field->kEigenschaft]))
				$x->min = trim($_REQUEST['min'][$field->kEigenschaft]);
			if(!empty($_REQUEST['step'][$field->kEigenschaft]))
				$x->step = trim($_REQUEST['step'][$field->kEigenschaft]);
			if(!empty($_REQUEST['max'][$field->kEigenschaft]))
				$x->max = trim($_REQUEST['max'][$field->kEigenschaft]);
			
			$x->showEinheit = (int) $_REQUEST['showEinheit'][$field->kEigenschaft];
			$x->useRangeSlider = (int) $_REQUEST['useRangeSlider'][$field->kEigenschaft];
			$x->showMinMax = (int) $_REQUEST['showMinMax'][$field->kEigenschaft];
			$x->hide = (int) $_REQUEST['hide'][$field->kEigenschaft];
			$x->readonly = (int) $_REQUEST['readonly'][$field->kEigenschaft];
			$x->einheit = trim($_REQUEST['einheit'][$field->kEigenschaft]);
			Shop::Container()->getDB()->insert('xplugin_km_artikelpreise_variationen',$x);
		}
	}
	\Shop::Smarty()->assign('success','Freitextfelder erfolgreich gespeichert.');
	
	Shop::Container()->getCache()->flush('km_artikelpreise');
}

\Shop::Smarty()->assign('oPlugin',$plugin);

if($action == 'duplicate' && isset($_REQUEST['copy']))
{
	$artikel = Shop::Container()->getDB()->select('tartikel','kArtikel', (int) $_REQUEST['kArtikel']);
	if(!$artikel)
	{
		\Shop::Smarty()->assign('error','Artikel von dem kopiert werden soll konnte nicht gefunden werden.');
	} else {
		$sqlFields = 'SELECT 
				teigenschaft.kEigenschaft,
				teigenschaft.kArtikel,
				teigenschaft.cName,
				xplugin_km_artikelpreise_variationen.min,
				xplugin_km_artikelpreise_variationen.max,
				xplugin_km_artikelpreise_variationen.step,
				xplugin_km_artikelpreise_variationen.einheit,
				xplugin_km_artikelpreise_variationen.showEinheit,
				xplugin_km_artikelpreise_variationen.useRangeSlider,
				xplugin_km_artikelpreise_variationen.showMinMax,
				xplugin_km_artikelpreise_variationen.hide,
				xplugin_km_artikelpreise_variationen.readonly,
				xplugin_km_artikelpreise_variationen.kArtikel as kArtikel2
			FROM teigenschaft
			LEFT JOIN xplugin_km_artikelpreise_variationen ON xplugin_km_artikelpreise_variationen.kEigenschaft = teigenschaft.kEigenschaft 
			WHERE teigenschaft.kArtikel = :kArtikel
			
			ORDER BY teigenschaft.cName ASC
			';
		$fields = Shop::Container()->getDB()->executeQueryPrepared($sqlFields,[':kArtikel' => (int) $_REQUEST['kArtikel']],2);
		
		foreach($fields as &$field3)
		{
			//Lade Optionen der Eigenschaft
			$eigenschaftSql = 'SELECT * FROM teigenschaftwert WHERE kEigenschaft=:kEigenschaft';
			$optionen = Shop::Container()->getDB()->executeQueryPrepared($eigenschaftSql,[':kEigenschaft' => (int) $field3->kEigenschaft],2);
			$field3->optionen = array();
			foreach($optionen as $option)
			{
				$field3->optionen[$option->kEigenschaftWert] = $option->cName;
			}
		}
					
		$sqlManipulations = 'SELECT * FROM xplugin_km_artikelpreise_manipulation WHERE kArtikel=:kArtikel ORDER BY sort';		
		$manipulations = Shop::Container()->getDB()->executeQueryPrepared($sqlManipulations,[':kArtikel' => (int) $_REQUEST['kArtikel']],2);
					
		
		$copies = preg_split('/\r\n|[\r\n]/', $_REQUEST['copy']);
		$results = array();
		foreach($copies as $copy)
		{
			if(trim($copy) != '')
			{
				$copyArtikel = Shop::Container()->getDB()->select('tartikel','cArtNr', trim($copy));
				if(!$copyArtikel)
				{
					$results[] = array('error' => 'Artikelnummer <strong>'.$copy.'</strong> wurde nicht gefunden.');
				} else {
					$checkArtikel = Shop::Container()->getDB()->select('xplugin_km_artikelpreise_basics','kArtikel', (int) $copyArtikel->kArtikel);
					//prüfen ob der Artikel schon eine Config hat!
					if($checkArtikel)
					{
						$results[] = array('error' => 'Artikel <strong>'.$copyArtikel->cName.' ('.$copyArtikel->cArtNr.')</strong> hat bereits eine Konfiguration.');
					}
					else
					{
						$sqlCopyFields = 'SELECT * FROM teigenschaft WHERE kArtikel=:kArtikel';
						$copyArtikelFields = Shop::Container()->getDB()->executeQueryPrepared($sqlCopyFields,[':kArtikel' => (int) $copyArtikel->kArtikel],2);

						foreach($copyArtikelFields as &$field2)
						{
							//Lade Optionen der Eigenschaft
							$eigenschaftSql = 'SELECT * FROM teigenschaftwert WHERE kEigenschaft=:kEigenschaft';
							$optionen = Shop::Container()->getDB()->executeQueryPrepared($eigenschaftSql,[':kEigenschaft' => (int) $field2->kEigenschaft],2);
							$field2->optionen = array();
							foreach($optionen as $option)
							{
								$field2->optionen[$option->kEigenschaftWert] = $option->cName;
							}
						}
						
						$replaces = array();
						//Jetzt Basics anlegen
						$obj = new stdClass;
						$obj->kArtikel = $copyArtikel->kArtikel;
						$obj->berechnungsBasis = false;
						$res =  Shop::Container()->getDB()->insert('xplugin_km_artikelpreise_basics',$obj);
						
						//Jetzt Feldmanipulationen durchgehen
						foreach($fields as $field)
						{
							//Jetzt im neuen Artikel suchen
							foreach($copyArtikelFields as $copyField)
							{
								if($copyField->cName == $field->cName)
								{
									if($field->kArtikel2 > 0)
									{
										$obj = new stdClass;
										$obj->min = $field->min;
										$obj->max = $field->max;
										$obj->step = $field->step;
										$obj->einheit = $field->einheit;
										$obj->showEinheit = $field->showEinheit;
										$obj->useRangeSlider = $field->useRangeSlider;
										$obj->showMinMax = $field->showMinMax;
										$obj->hide = $field->hide;
										$obj->readonly = $field->readonly;
										$obj->kArtikel = $copyArtikel->kArtikel;
										$obj->kEigenschaft = $copyField->kEigenschaft;
										$res =  Shop::Container()->getDB()->insert('xplugin_km_artikelpreise_variationen',$obj);
									}
									//Jetzt noch replaces vorbereiten
									$replaces[$field->kEigenschaft] = $copyField->kEigenschaft;
								}
							}
						}
						//Jetzt Preismanipulationen durchgehen
						foreach($manipulations as $manipulation)
						{
							$obj = new stdClass;
							$obj->kArtikel = $copyArtikel->kArtikel;
							$obj->sort = $manipulation->sort;
							//Jetzt alle vorkommen ersetzen
							$obj->formel = $manipulation->formel;
							foreach($fields as $field)
							{
								if(!array_key_exists($field->kEigenschaft,$replaces))
								{
									$manipulationError = 1;
									$obj->formel = str_replace('##e:'.$field->kEigenschaft.'##',0,$obj->formel);
									$obj->formel = str_replace('"eigenschaft":"'.$field->kEigenschaft.'"','"eigenschaft":"0"',$obj->formel);
									$obj->formel = str_replace('"field_input":"'.$field->kEigenschaft.'"','"field_input":"0"',$obj->formel);
									$obj->formel = str_replace('"verstecken":"'.$field->kEigenschaft.'"','"verstecken":"0"',$obj->formel);
								} else {
									$obj->formel = str_replace('##e:'.$field->kEigenschaft.'##','##e:'.$replaces[$field->kEigenschaft].'##',$obj->formel);
									$obj->formel = str_replace('"eigenschaft":"'.$field->kEigenschaft.'"','"eigenschaft":"'.$replaces[$field->kEigenschaft].'"',$obj->formel);
									$obj->formel = str_replace('"field_input":"'.$field->kEigenschaft.'"','"field_input":"'.$replaces[$field->kEigenschaft].'"',$obj->formel);
									$obj->formel = str_replace('"verstecken":"'.$field->kEigenschaft.'"','"verstecken":"'.$replaces[$field->kEigenschaft].'"',$obj->formel);
								}
								
								//EigenschaftWerte erseten: "eigenschaft_wert":"123"
								foreach($field->optionen as $wert=>$value)
								{
									foreach($copyArtikelFields as $x)
									{
										foreach($x->optionen as $copyWert=>$copyValue)
										{
											if($value == $copyValue)
											{
												$obj->formel = str_replace('"eigenschaft_wert":"'.$wert.'"','"eigenschaft_wert":"'.$copyWert.'"',$obj->formel);
											}
										}
									}
								}
							}
							//Jetzt speichern
							$res =  Shop::Container()->getDB()->insert('xplugin_km_artikelpreise_manipulation',$obj);
						}
						
						if($manipulationError != 0)
						{
							$results[] = array('error' => 'Der Artikel <strong>'.$copyArtikel->cName.' ('.$copyArtikel->cArtNr.')</strong> enh&auml;lt nicht die gleichen Variationen. Die nicht erkannten durch 0 ersetzt.');
						}
						$manipulationError = 0;
						//Erfolgsmeldung ausgeben
						$results[] = array('success' => 'Einstellungen wurden zu Artikel <strong>'.$copyArtikel->cName.' ('.$copyArtikel->cArtNr.')</strong> dupliziert.');
					}
				}
			}
		}
		
		\Shop::Smarty()->assign('results',$results);
	}
	$action = 'overview';
}
switch($action)
{
	case 'overview':
		$sqlOverview = '
			SELECT tartikel.* ,xplugin_km_artikelpreise_basics.*
			FROM xplugin_km_artikelpreise_basics 
			LEFT JOIN tartikel ON tartikel.kArtikel = xplugin_km_artikelpreise_basics.kArtikel
			ORDER BY 
				if(xplugin_km_artikelpreise_basics.fktattr = \'\' or xplugin_km_artikelpreise_basics.fktattr is null,1,0),xplugin_km_artikelpreise_basics.fktattr, tartikel.cName ASC';
		$artikel = Shop::Container()->getDB()->executeQueryPrepared($sqlOverview,[],2);
		if($artikel == 0) $artikel = array();
		\Shop::Smarty()->assign('artikel',$artikel);
		\Shop::Smarty()->display($plugin->getPaths()->getAdminPath() . 'templates/overview.tpl');
		break;
	case 'addArtikel':
	case 'editArtikel':
		\Shop::Smarty()->display($plugin->getPaths()->getAdminPath() . 'templates/form_article.tpl');
		break;
	case 'fields':
		if( isset($_REQUEST['kArtikel']) && (int) $_REQUEST['kArtikel'] > 0)
		{
			$artikel = Shop::Container()->getDB()->select('tartikel','kArtikel', (int) $_REQUEST['kArtikel']);
			if(!$artikel)
			{
				\Shop::Smarty()->display($plugin->getPaths()->getAdminPath() . 'templates/notfound.tpl');
				break;
			}
			$sqlFields = 'SELECT 
					teigenschaft.kEigenschaft,
					teigenschaft.kArtikel,
					teigenschaft.cName,
					xplugin_km_artikelpreise_variationen.min,
					xplugin_km_artikelpreise_variationen.max,
					xplugin_km_artikelpreise_variationen.step,
					xplugin_km_artikelpreise_variationen.einheit,
					xplugin_km_artikelpreise_variationen.showEinheit,
					xplugin_km_artikelpreise_variationen.useRangeSlider,
					xplugin_km_artikelpreise_variationen.showMinMax,
					xplugin_km_artikelpreise_variationen.hide,
					xplugin_km_artikelpreise_variationen.readonly,
					xplugin_km_artikelpreise_variationen.kArtikel as kArtikel2
				FROM teigenschaft
				LEFT JOIN xplugin_km_artikelpreise_variationen ON xplugin_km_artikelpreise_variationen.kEigenschaft = teigenschaft.kEigenschaft 
				WHERE teigenschaft.kArtikel = :kArtikel
				AND (teigenschaft.cTyp = "PFLICHT-FREIFELD" OR teigenschaft.cTyp="FREIFELD")
				ORDER BY teigenschaft.cName ASC
				';
			$fields = Shop::Container()->getDB()->executeQueryPrepared($sqlFields,[':kArtikel' => (int) $_REQUEST['kArtikel']],2);
		} else {
			$fields = array();
			$artikel = false;
			for($i=1;$i<=10;$i++)
			{
				$sqlFields = 'SELECT * FROM xplugin_km_artikelpreise_variationen WHERE fktattr=:fktattr AND kEigenschaft=:kEigenschaft';
				$field = Shop::Container()->getDB()->executeQueryPrepared($sqlFields,[':fktattr' => trim($_REQUEST['fktattr']),':kEigenschaft' => $i],1);
				
				$fields[] = (object)array(
					'kEigenschaft' => $i,
					'kArtikel' => 0,
					'fktattr' => trim($_REQUEST['fktattr']),
					'cName' => 'Freitextfeld '.$i,
					'min' => ($field) ? $field->min : '',
					'max' => ($field) ? $field->max : '',
					'step' => ($field) ? $field->step : '',
					'einheit' => ($field) ? $field->einheit : '',
					'showEinheit' => ($field) ? $field->showEinheit : '',
					'useRangeSlider' => ($field) ? $field->useRangeSlider : '',
					'showMinMax' => ($field) ? $field->showMinMax : '',
					'hide' => ($field) ? $field->hide : '',
					'readonly' => ($field) ? $field->readonly : '',
					'kArtikel2' => ($field) ? 1 : 0,
				);
			}
		}
		
		if($fields == 0) $fields=array();
		\Shop::Smarty()->assign('artikel',$artikel);
		\Shop::Smarty()->assign('fktattr', isset($_REQUEST['fktattr']) ? trim($_REQUEST['fktattr']) : '');
		\Shop::Smarty()->assign('fields',$fields);
		\Shop::Smarty()->display($plugin->getPaths()->getAdminPath() . 'templates/fields.tpl');
		break;
	case 'manipulations':
		if(isset($_REQUEST['kArtikel']) && (int) $_REQUEST['kArtikel'] > 0)
		{
			$artikel = Shop::Container()->getDB()->select('tartikel','kArtikel', (int) $_REQUEST['kArtikel']);
			if(!$artikel)
			{
				\Shop::Smarty()->display($plugin->getPaths()->getAdminPath() . 'templates/notfound.tpl');
				break;
			}
			$sqlManipulations = 'SELECT * FROM xplugin_km_artikelpreise_manipulation WHERE kArtikel=:kArtikel ORDER BY sort';
			$manipulations = Shop::Container()->getDB()->executeQueryPrepared($sqlManipulations,[':kArtikel' => (int) $_REQUEST['kArtikel']],2);
			
			//Moegliche Variationsfelder
			$sqlFields = 'SELECT * FROM teigenschaft WHERE kArtikel=:kArtikel';
			$fields = Shop::Container()->getDB()->executeQueryPrepared($sqlFields,[':kArtikel' => (int) $_REQUEST['kArtikel']],2);
			foreach($fields as &$field)
			{
				//Lade Optionen der Eigenschaft
				$eigenschaftSql = 'SELECT * FROM teigenschaftwert WHERE kEigenschaft=:kEigenschaft';
				$optionen = Shop::Container()->getDB()->executeQueryPrepared($eigenschaftSql,[':kEigenschaft' => (int) $field->kEigenschaft],2);
				$field->optionen = array();
				foreach($optionen as $option)
				{
					$field->optionen[] = array(
						'key' => $option->kEigenschaftWert,
						'value' => ($option->cName)
					);
				}
				
				$field->optionen = json_encode($field->optionen);
			}
		} else {
			$sqlManipulations = 'SELECT * FROM xplugin_km_artikelpreise_manipulation WHERE fktattr=:fktattr ORDER BY sort';
			$manipulations = Shop::Container()->getDB()->executeQueryPrepared($sqlManipulations,[':fktattr' => trim($_REQUEST['fktattr'])],2);
			
			//Mögliche Variationsfelder
			$values = array();
			for($i=1;$i<=100;$i++)
			{
				$values[] = array(
					'key' => $i,
					'value' => 'Variationswert '.$i
				);
			}
			
			$fields = array();
			for($i=1;$i<=10;$i++)
			{
				//Selects
				$fields[] = (object) array(
					'cTyp' => 'SELECT',
					'kEigenschaft' => $i,
					'cName' => 'Variation '.$i,
					'optionen' => json_encode($values)
				);
			}
			for($i=1;$i<=10;$i++)
			{
				//Freitextfelder
				$fields[] = (object) array(
					'cTyp' => 'FREIFELD',
					'kEigenschaft' => ($i+100),
					'cName' => 'Freitextfeld '.$i,
					'optionen' => json_encode(array())
				);
			}
		}
		
		//Lade jetzt die bestehenden Manipulationen
		foreach($manipulations as &$x)
			$x->json = json_decode($x->formel);
		
		
		\Shop::Smarty()->assign('artikel',isset($artikel) ? $artikel : 0);
		\Shop::Smarty()->assign('fktattr',isset($_REQUEST['fktattr']) ? trim($_REQUEST['fktattr']) : 0);
		\Shop::Smarty()->assign('fields',$fields);
		\Shop::Smarty()->assign('manipulations',$manipulations);
		\Shop::Smarty()->display($plugin->getPaths()->getAdminPath() . 'templates/manipulations.tpl');
		break;
	case 'duplicate':
		$artikel = Shop::Container()->getDB()->select('tartikel','kArtikel', (int) $_REQUEST['kArtikel']);
		\Shop::Smarty()->assign('artikel',$artikel);
		\Shop::Smarty()->display($plugin->getPaths()->getAdminPath() . 'templates/duplicate.tpl');
		break;
	default:
		echo "Unknown action. Aborting.";
}